#include "clock.h"
//v3		//    .
//v2.05
//v2.04	 	// 
//v2.03  	//    t SEE
//V2.02  	//  -  

//--------------------------------------
static void port_init(void)
{
DDRLCD=0xFF;
DDRSERIAL|=PIN_SERIAL|sig_min_00;
DDR_OUT|=PIN_calls1 | PIN_calls_osn | PIN_timer;
PORT_POWER_DETECT|=_power_;
}
//**************************************
//void timer0_init(void){
//	TCCR0=0x01;
//}
//**************************************
static void timer2_init(void)
{
 TCCR2 = 0x00; 		  //stop
 ASSR  = (1<<AS2);	  //set async mode
 TCCR2 = 0x01; 		  //start
}
//**************************************
void timer1_init(void)
{
 TCCR1B = 0; //stop
 TCCR1A	= 0;
 OCR1AH = ocr1[ocr1ahi];
 OCR1AL = ocr1[ocr1alow];
 DDR_OC1A  &=~ OC1A;	  //OC1A 
}
//**************************************
void timer1_init_in_pwm(void)
{
	DDR_OC1A |= OC1A;		//OC1A
	TCCR1B = 0; 			//stop
	TCCR1A = (1<<COM1A0);	//Toggle OC1A/OC1B on Compare Match //TCCR1B WGM12=1 CTC top-OCR1A
}
//**************************************	
void shim_true(void){
	timer1_init_in_pwm();
	TCCR1B=(1<<CS10)|(1<<WGM12);
}
//**************************************

void init_devices(void)
{
 cli(); //disable all interrupts
 port_init();
 TCCR0=0x01;//timer0_init();
 timer1_init();
 MCUCR = 0x00;
 GICR  = 0x00;
 ACSR=_BV(ACD);
 TIMSK =(1<<TOIE2)|(1<<TOIE0); //(1<<OCIE2)| timer interrupt sources |(1<<OCIE1A)
 sei(); //re-enable interrupts
}

// ***********************************************************
//   
unsigned char EEPROM_READ(unsigned int uiAddress)
{
	/*     */
	while(EECR & (1<<EEWE));
	/*    */
	EEAR = uiAddress;
	/*       EERE */
	EECR |= (1<<EERE);
	/*      */
	return EEDR;
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_READ(uiAddress)!=ucData){
		/*     */
		PORTSERIAL|=_BV(STORAGE);
		while(EECR & (1<<EEWE))
		
		cli();
		/*     */
		EEAR = uiAddress;
		EEDR = ucData;
		/*  . 1   EEMWE */
		EECR |= (1<<EEMWE);
		/*       EEWE */
		EECR |= (1<<EEWE);
		sei();
		}
}
//*********************************************
void read_data_EEPROM(void)
{
uint8_t *a,i;

		a=&calls[0][0];
		for(uint8_t i=EEPROM_calls; i < 12*3+EEPROM_calls ; i++, a++){
				*a=EEPROM_READ(i);
				}

		a=(uint8_t*)&reg_state_time;
		for(uint8_t i=EEPROM_regim_state_time; i< sizeof(reg_state_time)+EEPROM_regim_state_time  ; i++, a++)
			*a=EEPROM_READ(i);	
			

		otsroshka_num=EEPROM_READ(EEPROM_otsrochka_num);
		signal_bud=EEPROM_READ(EEPROM_sig_pin_or_bip);
		
		if ( EEPROM_READ(EEPROM_verifu_but)==0xaa){
			for( i=EEPROM_ocr1a; i<4+EEPROM_ocr1a ; i++)
				ocr1[i-EEPROM_ocr1a]=EEPROM_READ(i);
				}
				
		//if ( (i=EEPROM_READ(EEPROM_light))<sizeof(light_swith)){
		a=(uint8_t*)&lights;
		for( i=EEPROM_light; i< sizeof(lights)+EEPROM_light  ; i++, a++)
			*a=EEPROM_READ(i);

		if ( lights[day_light]>=sizeof(light_swith) ) {
			lcd_light=lights[day_light]=lights[night_light]=5;
			}
			else lcd_light=lights[day_light];

		if ( (i=EEPROM_READ(EEPROM_correction)) < sizeof(corr_in_lcd)/2 )
		{
		correction=i;
		corr_flag=EEPROM_READ(EEPROM_corr_flag);
		}
		
		vid_t=EEPROM_READ(EEPROM_vid_t);
		
		
		current_state_view.time=1;
}

//*************** 1 Wire DALLAS ************************************************
void pullup_off(void){
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	PORT_1wire&=~pwire0;
	PORT_1wire&=~pwire1;
}
//***********************************************
unsigned char readbit(void){
unsigned char i;
	cli();
	DDR_1wire|=out_1wire;//line down

//	asm("nop");
	asm("nop");
	asm("nop");//1.25us
	DDR_1wire&=~out_1wire;//line up through 1.25us
	_delay_us(12);//11
	i=PIN_1wire;
	sei();
	_delay_us(47);//47
	return i;
}

//***********************************************
void readbyte(uint8_t *pw) {  
unsigned char i, r, read_byte[2]={0,0}, pinwire;

pullup_off();
for(i=0, r=1; i<8; i++){
	pinwire=readbit();
	if ( pinwire & pwire0 ) read_byte[0]|=r;
	if ( pinwire & pwire1 ) read_byte[1]|=r;
	r<<=1;
	}
PORT_1wire|=power_suplly_1w;
DDR_1wire|=power_suplly_1w;
pw[0]=read_byte[0];	
pw[1]=read_byte[1];
}
//***********************************************
void writebit0(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(60);//60
	DDR_1wire&=~out_1wire;
	sei();
}
//***********************************************
void writebit1(void){
	cli();
	DDR_1wire|=out_1wire;
	_delay_us(3);
	DDR_1wire&=~out_1wire;
	sei();
	_delay_us(57);//57
}
//***********************************************
void writebyte(unsigned char byte){
unsigned char i;
pullup_off();
	for(i=0; i<8; i++){
		if (byte&_BV(0)) 
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;
}
//****************************************

void detectPresence(void){
unsigned char i;
	
	pullup_off();
	out_1wire=pwire0|pwire1;
	
	DDR_1wire|=pwire0;
	DDR_1wire|=pwire1;
	_delay_ms(0.48);//0.48
	
	cli();
	DDR_1wire&=~pwire0;
	DDR_1wire&=~pwire1;
	_delay_us(60);//60
	i=PIN_1wire;
	sei();
	
	if ( i & pwire0 ) out_1wire&=~pwire0;
	if ( i & pwire1 ) out_1wire&=~pwire1;

	if ( out_1wire == 0 ){
		count_com_1w=0; 
		return;
		}
	
	_delay_ms(0.42);//0.42
	i=PIN_1wire;
	if (!( i & pwire0 )) out_1wire&=~pwire0;
	if (!( i & pwire1 )) out_1wire&=~pwire1;
	
	if ( out_1wire == 0 ){
		count_com_1w=0; 
		return;
		}
			
	power_suplly_1w &= out_1wire;
	PORT_1wire|=power_suplly_1w;
	DDR_1wire|=power_suplly_1w;	
}

//****************************************
void scratchpad_save(void){

		detectPresence();//  
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
		writebyte(5);//	TH
		writebyte(5);//	TL
		writebyte(0x7f);//	Statys 12bit
		
		detectPresence();//   EEPROM
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x48);//COPY SCRATCHPAD [48h]
		PORT_1wire|=power_suplly_1w;
		DDR_1wire|=power_suplly_1w;
}



//****************************************
void izmerenie_t(void){
//int t_point;

	if (regim) return;//        

	if ( !count_com_1w ){//
		count_com_1w++;
power_suplly_1w=0;
		detectPresence();//  
		return;
		}

	if ( count_com_1w == 1 ){
		count_com_1w++;

		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xB4);//READ POWER SUPPLY [B4h]
pullup_off();
		power_suplly_1w=readbit();//     
		power_suplly_1w=~power_suplly_1w;//    ,  
		power_suplly_1w &= out_1wire;//pwire0|pwire1;
		return;
		}

	if ( count_com_1w == 2 ){	// 
		count_com_1w++;
		detectPresence();//
		return;
		}

	if ( count_com_1w == 3 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x44);//CONVERT T [44h]
		time[wire1]=120;//1sek
		return;
		}

	if ( count_com_1w == 4 ){
		if (time[wire1]<-8) count_com_1w++;
		return;
		}

	if ( count_com_1w == 5 ){// e
		count_com_1w++;
		detectPresence();//
		return;
		}

	if ( count_com_1w == 6 ){
		count_com_1w++;
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0xBE);//READ SCRATCHPAD [BEh]
		return;
		}

	if ( count_com_1w == 7 ){
		count_com_1w=0;
		readbyte(tempir_lsb);// 
		readbyte(tempir_msb);
		//format_t(0);
		//format_t(1);
		}

}
//*************** END 1 Wire *********************
//***********************************************/
void change_light_var(void)
{
		if ( time_flag & _BV(fl_plus) )
		   {
		   if (++change_light>=lcd_light) time_flag &= ~_BV(fl_plus);//    
		   }
		   else
		   {
		   if (change_light>1) change_light--; else time_flag|=_BV(fl_plus);//  
		   }
}
//**************************************
uint8_t opred_light_current_num(void)
{
  char l;
  unsigned int a=0x100;
 	
	l=lcd_light;

	if (mask)
	 	{
		a>>=znakomesto;
		if ( mask&a ) l=change_light;
		}
		else	
		{
		time_flag&=~_BV(fl_plus);
		change_light=lcd_light;
		}
	return l;
}

//******************74hc595***********************************
void data_shift(unsigned char data)
{
	for(uint8_t i=8; i ; i--){//   8 
	if (data & _BV(7) )  PORTSERIAL|=_BV(DATA);
					else   PORTSERIAL&=~_BV(DATA); 
	data<<=1;
	PORTSERIAL|=_BV(SHIFT);
	PORTSERIAL&=~_BV(SHIFT);
	}
}

void display(void)
{
	PORTSERIAL|=_BV(STORAGE);// 
#ifdef katod 
	data_shift(~(1<<(znakomesto)));
#else
	data_shift(1<<(znakomesto));
#endif
	
	PORTSERIAL&=~_BV(STORAGE);
	PORTSERIAL|=_BV(STORAGE);
	PORTSERIAL&=~_BV(STORAGE);
	
	if (znakomesto==7){
	PORTSERIAL|=_BV(SHIFT);
	PORTSERIAL&=~_BV(SHIFT);
	}
	if (znakomesto==8)   
	#ifdef katod
		data_shift(0x0);
	#else
		data_shift(0xFF);
	#endif
	PORTSERIAL&=~(_BV(DATA)|_BV(SHIFT)|_BV(STORAGE));  
}

//*************************************************************
void skankey (void){
	unsigned char key_lokal=17;
	
	key=key_lokal;
	
	// PORTID|=pin_id;
	PORTSERIAL|=_BV(STORAGE);

	DDRLCD =0xF0;
	PORTLCD=0x0F;
	_delay_us(10);
	
	if (!str0)	    	key_lokal=0;
	else if (!str4)	key_lokal=4;
	else if (!str8)	key_lokal=8;
	else if (!str12)	key_lokal=12;
	else key_lokal=17;//goto vool;
/*	
	 DDRLCD =0x0F;
	 PORTLCD=0xF0;
	 delay(15);
	
	 if (!stolb1)		key_lokal+=1;
	 else if (!stolb2)	key_lokal+=2;
	 else if (!stolb3)	key_lokal+=3;
	 else if (!stolb4)	key_lokal+=4;
	 else
vool:	 key_lokal=17;
*/	
	 if ( key_lokal!=17 )
	 {
	   if (++anti_drebezg[0]==35)//35)
	   	  {
		  key=key_lokal;
		  if ( ( ocr1[ocr1ahi_but] )||( ocr1[ocr1alow_but] ) ){
			OCR1AH  = ocr1[ocr1ahi_but];//0x04;
			OCR1AL  = ocr1[ocr1alow_but];//0x00;
			shim_true();//
			time_flag|=_BV(fl_sig_butt);
			time[note_but]=7;
			}
		  }
	   if (anti_drebezg[0]==anti_drebezg[2]){	//anti_drebezg[0]  
	   	   anti_drebezg[0]=0;					//anti_drebezg[1] -   
		   anti_drebezg[1]++;					//anti_drebezg[2]    
		   if (anti_drebezg[1]==3) anti_drebezg[2]=45;//55;
		   }	
	   time_in_regim=25;
	 }
	 else
	 {
	   anti_drebezg[0]=0;
	   anti_drebezg[1]=0;
	   anti_drebezg[2]=200;
	 }
	 #ifdef katod
	 PORTLCD=0x00;
	 #else
	 PORTLCD=0xFF;
	 #endif
	 DDRLCD =0xFF;
}

//**************************************
void inc_dec_var_bit(unsigned char *var,unsigned char bit_n){
		if (PLUS)	 (*var)|= _BV(bit_n);
		if (MINUS) 	 (*var)&=~_BV(bit_n);
}

//**************************************
void inc_dec_var(unsigned char *var, unsigned char limit){
		if (PLUS){
			if ((*var)<limit)	(*var)++; 
			else *var=0;
			}
		if (MINUS){
			if (*var) (*var)--;
			else *var=limit;
			}
}
//**************************************
void mask_next_regim(unsigned int m, unsigned char next_F,unsigned char SET)
{
 	 if (!anti_drebezg[0])  mask=m; 
	 if (F_)   regim=next_F;
	 if (SET_) regim=SET;
	 key=17;
}

void next_regim(void){
	if (PLUS) {
		if (regim<218) 
		regim++;
		}
	if (MINUS) {
		if (regim>211)
		regim--;
		}
}

void reg_see_init(void){
	current_state_view.regim=0;
	current_state_view.time=3;
}

//**************************************
void key_action(void)
{//mask_next_regim( maska regima, if (key F_), if (key SET_) )
	mask=0;

	if ( signal ){
		if (key!=17)
		if (!( (regim>=52)&&(regim<=54) )) 
			{ 
			time_flag|= _BV(fl_signal_cls);
			time_flag&=~_BV(fl_signal_out_enable);
			if (F_) time_flag&= ~_BV(fl_sig_otsr);//        ,  
			regim=0;
			return;
			}
		}

	if (!regim) {
		if (F_) {
			regim=7;
			}
			else
		if (SET_){
		   regim=100;
		   }
		   else
		if (MINUS) regim=31;
			else
		if (PLUS) {
			regim=91;
			reg_see_init();
			}
		return;
		}
		
	if (regim==7) { mask_next_regim(0xFFFF,8,31); return;}//calls	
	if (regim==8) { mask_next_regim(0xFFFF,9,3); 	return;}//timer
	if (regim==9) { mask_next_regim(0xFFFF,0,211);  return;}//setup

	if (regim==100) {//  set      100
		if ( (MINUS)||(PLUS) ) {
			time_flag&=~_BV(fl_sig_otsr);
			regim=0;
			}
		mask_next_regim(0,7,0);
		return;
		}

	//---------------------timer-------------------------
	 if (regim==3) {
		mask_next_regim(0,0,80);//t00-00-00
		return;
		}
	 if (regim==80) { //true chet timer
	 	inc_dec_var_bit(&timer[3], fl_timer_chet);
		if (PLUS) regim=3;
		mask_next_regim(0b100000000,3,81);
		return;
	 	}
	 if (regim==81) {//set hour timer
	 	inc_dec_var(&timer[2],99);
	 	mask_next_regim(0b11000000,3,82);
		return;
		}
	 if (regim==82) {//set min timer
	 	inc_dec_var(&timer[1],59);
	 	mask_next_regim(0b11000,3,83);
		return;
		}
	 if (regim==83) {//set sek timer
	 	inc_dec_var(&timer[0],59);
	 	mask_next_regim(0b11,3,80);
		return;
		}	
	//----------------------------------------------
	 //CALLS//****************************
	 if (regim==31) {//set number calss
	 	inc_dec_var(&budilnik_nomer,11);
	 	mask_next_regim(0b100000000,0,32);
		return;
	 	}
	 if (regim==32) {//on off calls
	 	inc_dec_var_bit(&calls[ budilnik_nomer ][2], 7 );
	 	mask_next_regim(0b11000000,31,33);
		return;
	 	}
	 if (regim==33) {//set hour calss
	 	inc_dec_var(&calls[ budilnik_nomer ][c_hour],23);
	 	mask_next_regim(0b11000,31,34);
		return;
	 	}
	 if (regim==34) {//set min calls
	 	inc_dec_var(&calls[ budilnik_nomer ] [c_min],59);
		uint8_t a;
		if (budilnik_nomer<10) a=35; else a=45;
	 	mask_next_regim(0b11,31,a);
		return;// 
	 	}

	for(uint8_t i=35, a=0; i<42 ;i++,a++){
	  if (regim==i) {//set day calss
	 	inc_dec_var_bit( &calls[ budilnik_nomer ][2], a );
	 	mask_next_regim(_BV(6-a),31,i+1);
		break;
	 	}
	}
	if (regim==42) {//save current budilnik in eeprom
		uint8_t a, i;
		for( a=EEPROM_calls+budilnik_nomer*3, i=0 ;  i<3  ;a++, i++) 
			EEPROM_write( a, calls[budilnik_nomer][i]);
		regim=31;
		return;
		}
	 if (regim==45) {
		inc_dec_var(&calls_pin[budilnik_nomer-10][c_hour],23); 
		mask_next_regim(0b11000,31,46);
		return;
	 	}
	 if (regim==46) {// set min
	 	inc_dec_var(&calls_pin[budilnik_nomer-10][c_min],59);
		mask_next_regim(0b11,31,35);
		return;
	 	}
	//---------------- end calls -------------------	

	//-----------------PORT-------------------------
	 if (regim==212) {//120
		next_regim();
		mask_next_regim(0xFFFF,0,71);//Port  C	
		return;
		}
	 if (regim==71) {//_pin-0_ _c								   
	 	if (PLUS) PORT_OUT|=PIN_calls1;
		if (MINUS) PORT_OUT&=~PIN_calls1;
		mask_next_regim(0b1000,212,212);
		return;
		}
	//--------------------END PORT-----------------
#define r_clock	21
	//--------------------CLOCK--------------------
	if (regim==211) {//121
		next_regim();
		mask_next_regim(0xFFFF,0,r_clock); 
		return; 
		}//clock 4ACb|
	
	// 12-00-00
	if (regim==r_clock) {//set hour sek
	 	if (MINUS){
			if (hour[h_sek]>31){ 
				hour[h_sek]=60;
				isr_1sek_=1;
				}else
				hour[h_sek]=0;
			clock_=0;
			}
	 	mask_next_regim(0b11,211,r_clock+1);
		return;
		}
 	if (regim==r_clock+1) {//set min 
	 	inc_dec_var(&hour[h_min],59);
	 	mask_next_regim(0b11000,211,r_clock+2);
		return;
		}
	if (regim==r_clock+2) {//set hour
	 	inc_dec_var(&hour[h_hour],23);
	 	mask_next_regim(0b11000000,211,r_clock+3);
		return;
		}
	//28.07.08 
	if (regim==r_clock+3) {//set num hour
	 	inc_dec_var(&hour[h_num],31-1);
	 	mask_next_regim(0b110000000,211,r_clock+4);
		return;
		}
	if (regim==r_clock+4) {// set month hour
	 	inc_dec_var(&hour[h_month],12-1);
	 	mask_next_regim(0b1100000,211,r_clock+5);
		return;
		}	
	if (regim==r_clock+5) {// set month year
	 	inc_dec_var(&hour[h_year],99);
	 	mask_next_regim(0b11000,211,r_clock+6);
		return;
		}	
	if (regim==r_clock+6) {//set day hour
	 	inc_dec_var(&hour[h_day],7-1);
	 	mask_next_regim(0b11,211,r_clock+7);
		return;
		}
	// 
	if (regim==r_clock+7) {//set corection znak
	 	inc_dec_var_bit(&corr_flag, fl_corr_znak_pl);
	 	mask_next_regim(0x10,211,r_clock+8);
		return;
		}
	if (regim==r_clock+8) {//set hour
	 	inc_dec_var(&correction,sizeof(corr_in_lcd)/2-1);
	 	mask_next_regim(0x0F,0,211);
		if (regim==211) {
			EEPROM_write(EEPROM_correction, correction);
			EEPROM_write(EEPROM_corr_flag,   corr_flag);
			}
		return;
		}
	//-----------------end cklock-----------------------
	
	//-------------SEE----------------
	if (regim==213){//122
		reg_see_init();
		next_regim();
		mask_next_regim(0xFFFF,0,91);//_t_SEE_
		return;
		}
	if (regim==91) {//F1 r.1-000 
		inc_dec_var( &current_state_view.regim, Count_regim-1);
	 	mask_next_regim(0b100000000,213,92);//BIT(8)
		return;
		}	
	if (regim==92) {//F1 r.1-000 
	 	inc_dec_var(&reg_state_time.regim[current_state_view.regim],num_formats);
	 	mask_next_regim(0b1000000,91,93);
		return;
		}	
	if (regim==93) {//r.1-000 F1
	 	inc_dec_var(&reg_state_time.time[current_state_view.regim],99);
	 	mask_next_regim(0b1100,91,94);
		return;
		}
	if (regim==94) {//F1 r.1-000 
	 	inc_dec_var(&reg_state_time.skip[current_state_view.regim],9);
	 	mask_next_regim(0b1,95,95);
		
		return;
		}
	if (regim==95) {
		uint8_t *a, i;
		a=(uint8_t*)&reg_state_time;
		for(i=EEPROM_regim_state_time; i<sizeof(reg_state_time)+EEPROM_regim_state_time ; i++)
			EEPROM_write( i, *(a++) );

		regim=91;
		return;
		}
	//-------------END SEE----------------
	
	//-------------yct bud----------------
	if (regim==214) {//123
		next_regim();
		mask_next_regim(0xFFFF,0,75);//yct bud	
		return;
		}
	if (regim==75) {//CAL. bIP C
	 	inc_dec_var(&signal_bud, 2);
		mask_next_regim(0x0E,214,76);
		return;
		}
	if (regim==76) {//otsroch. on
		time_flag&=~_BV(fl_sig_otsr);
		inc_dec_var(&otsroshka_num, 30);
		mask_next_regim(0b000000011,214,214);
		if (regim==214) {//    
			EEPROM_write(EEPROM_sig_pin_or_bip, signal_bud );
			EEPROM_write(EEPROM_otsrochka_num, otsroshka_num );
			}
		return;			  	
		}
	//-------------------end  yct bud--------------------

	//-------------------light--------------------------
	if (regim==215) {//125
		next_regim();
		mask_next_regim(0xFFFF,0,11); 
		return; 
		}//light
	if (regim==11) {
	 	inc_dec_var(&lights[day_light],sizeof(light_swith)-1);
		//if (lights[day_light]==0) lights[day_light]=1;
	 	mask_next_regim(0x100,215,14);
		return;
		}
	if (regim==14) {
	 	inc_dec_var(&lights[night_light],sizeof(light_swith)-1);
		//if (lights[night_light]==0) lights[night_light]=1;
	 	mask_next_regim(0b10,215,15);//noch L.5
		return;
		}
	if (regim==15) {
		inc_dec_var(&lights[tim_c_light],23);
		mask_next_regim(0b1100000,215,16);
		return;
		}
	if (regim==16) {
		inc_dec_var(&lights[tim_do_light],23);
		mask_next_regim(0b11,215,215);
		//*
		if (regim==215) {
			for(uint8_t i=EEPROM_light, a=0; i< sizeof(lights)+EEPROM_light  ; i++, a++)
				EEPROM_write( i, lights[a]);
			}
		//*/
		return;
		}
	//---------------end__light--------------------
	
	
	//------------SIGHAL---------------------------
	if (regim==216){//124
		next_regim();
		mask_next_regim(0xFFFF,0,52);//SIGHAL
		return;
		}
	if (regim==52){
		inc_dec_var(&ocr1[4],1);
		mask_next_regim(0b011111100,216,53);//53budil 54button 
		time[note]=3;
		time_flag|= _BV(fl_signal_cls);
		return;
		}
	if (regim==53) {//H000 L000
	 	inc_dec_var(&ocr1[ocr1[4]*2],0xFF);//ocr1ahi
	 	mask_next_regim(0b011100000,55,54);
		return;
		}
	if (regim==54) {//H000 L000 
	 	inc_dec_var(&ocr1[ocr1[4]*2+1],0xFF);//ocr1ahi
	 	mask_next_regim(0b000000111,55,53);
		return;
		}
	if (regim==55) {
	 	EEPROM_write(EEPROM_verifu_but, 0xaa);
		for(uint8_t i=EEPROM_ocr1a; i<4+EEPROM_ocr1a ; i++)
			EEPROM_write(i, ocr1[i-EEPROM_ocr1a]);
		regim=52;
		return;
		}
	//-------------end__signal--------------
	
	//-------------ds18b20------------------
	if (regim==217) {
		next_regim();
		mask_next_regim(0xFFFF,0,111);
		return; 
		}
	if (regim==111) {
		inc_dec_var(&vid_t,1);//ocr1ahi
		mask_next_regim(0x20,217,112); 
		if ( regim==112 ) EEPROM_write(EEPROM_vid_t,vid_t);
		return;
		}
	if (regim==112) {
		mask_next_regim(0,217,217); 
		if (regim==217) {
			scratchpad_save();		 
			}
		return;
		}
	//-----------end=ds18b20----------------
	
	//----------------------------------
	if (regim==218) {
	 	if (SET_){
			current_state_view.viewstate=0;
			for(uint8_t i=EEPROM_calls; i < 12*3+EEPROM_calls ; i++){
		  		EEPROM_write( i, 0 ); //
				}
			for(uint8_t i=EEPROM_regim_state_time; i<sizeof(reg_state_time)+EEPROM_regim_state_time ; i++)
				EEPROM_write( i, 0 );
			for(uint8_t i=EEPROM_ocr1a; i<4+EEPROM_ocr1a ; i++)
				EEPROM_write( i, 0 );

			EEPROM_write( EEPROM_light,   5);
			EEPROM_write( EEPROM_light+1, 2);
			EEPROM_write( EEPROM_light+2, 23);
			EEPROM_write( EEPROM_light+3, 6);
			
			for(uint8_t i=EEPROM_ocr1a; i<4+EEPROM_ocr1a ; i++)
				EEPROM_write( i, 4 );

			EEPROM_write( EEPROM_sig_pin_or_bip, 0);
			EEPROM_write( EEPROM_otsrochka_num, 7);
			EEPROM_write( EEPROM_vid_t, 0);
		//sei();		
			read_data_EEPROM();
		   }
		next_regim();
	 	mask_next_regim(0xFFFF,0,0);
		return;
		}
	 //_______________________________________________
}

//**************************************
void result_in_bcd(int result)
{//0000 0000 0000 (1)0000  // (2)0000 (3)0000 (4)0000 (5)0000 hi2 hi3 low4 low5
    unsigned char dig_out=0;
	bcd_num1=0;
	bcd_num2=0;
	bcd_num3=0;
	bcd_num4=0;
	while (result >= 10000) {
	 result -= 10000;
 	 dig_out ++;
	}
	bcd_num0=dig_out;
    dig_out = 0;
	while (result >= 1000) {
	 result -= 1000;
 	 dig_out ++;
	}
	bcd_num1=dig_out;
    dig_out = 0;
	while (result >= 100)  {
 	 result -= 100;
	 dig_out ++;
	 }
	bcd_num2=dig_out;
	dig_out = 0;
	while (result >= 10)   {
	 result -= 10;
	 dig_out ++;
	 }
	bcd_num3=dig_out;
	bcd_num4= result;
}
//**************************************
void cls_lcd_buffer(void){
unsigned char i;
 for(i=0;i<9;i++){
	lcd_buffer[i]=0;
	}
}
//**************************************
void load_str_in_lcdbuffer(const unsigned char *str_lcd){
unsigned char b,e,length;//str_lcd[0] = 0000 1111-, 1111 0000 -  
	length=str_lcd[0];
	for( b=0x0F&(length), e=1 ; b<(0x0F&(length>>4)) ; b++, e++){
		lcd_buffer[b]=str_lcd[e];
		}
}
//**************************************
void num2_bcd_in_lcd(unsigned char znak_mesto, unsigned char param_out)
{
 	result_in_bcd(param_out);
	lcd_buffer[znak_mesto]=font[bcd_num3];
	lcd_buffer[znak_mesto+1]  =font[bcd_num4];
}
void num3_th_in_lcd_buffer(unsigned char m){
	lcd_buffer[m]	=font[bcd_num2];
	lcd_buffer[m+1]	=font[bcd_num3];
	lcd_buffer[m+2]	=font[bcd_num4]^tochka;
}
//**************************************
void blank_nul(unsigned char mesto){
 if (lcd_buffer[mesto]==font[n0]) 
	lcd_buffer[mesto]=0;
}

//**************************************
void clock_in_lcd_gl(unsigned char znakomesto)
{
 	num2_bcd_in_lcd(znakomesto,hour[h_hour]);
	blank_nul(znakomesto);
	#ifdef miganie
 	if (time_flag&_BV(fl_sek_1_switch))
	#endif
		lcd_buffer[znakomesto+2]=font[f_seg_g];
	num2_bcd_in_lcd(znakomesto+3,hour[h_min]);
}
//**************************************
void clock_in_lcd0(void)
{
 	num2_bcd_in_lcd(0,hour[h_num]+1);
	lcd_buffer[1]^=tochka;
	result_in_bcd(hour[h_day]+1);
	lcd_buffer[2]=font[bcd_num4];
	clock_in_lcd_gl(4);
}
//**************************************
void day_str(void){
	lcd_buffer[7]=h_day_str[hour[h_day]*2];
	lcd_buffer[8]=h_day_str[hour[h_day]*2+1];
}
//**************************************
void clock_day_str(void){
	clock_in_lcd_gl(1);
	day_str();
}
//**************************************
void lcd_hh_mm(unsigned char *param){
	num2_bcd_in_lcd(4,*param);
	lcd_buffer[6]=font[f_seg_g];
	num2_bcd_in_lcd(7,*(param-1));
}
//**************************************
void num_month_day(void){//iln
	num2_bcd_in_lcd(1, hour[h_num]+1);
	lcd_buffer[3]=font[f_seg_d];
	num2_bcd_in_lcd(4, hour[h_month]+1);
	lcd_buffer[6]=font[f_seg_d];
	day_str();
}
//**************************************

void tempir_in_bcd(unsigned char t, unsigned char mesto, unsigned char pin_wire, unsigned char point){
unsigned char znak=0, n1=0,n2=0;

	if ( !(pin_wire & out_1wire) ){
	 	lcd_buffer[mesto]	=font[f_seg_g];
		lcd_buffer[mesto+1]	=font[f_seg_g];
		lcd_buffer[mesto+2]	=font[f_seg_g];
		}
		else
		{

	int te;
	te=((unsigned int)(tempir_msb[t]<<8))|tempir_lsb[t];//msb
	te=(te*10)>>4;

		if ( te<0 ){
			te*=-1;
			znak=1;
			}

		result_in_bcd(te);// 15.7 104.3 -55.2 5.2 -5.3
		
		if (vid_t==0)
		{
			if ( bcd_num1 ) n1=font[bcd_num1];
			else 
			if (znak) 	n1=font[f_seg_g];
			n2=font[bcd_num2];
		} 
		else
		{
			if ( bcd_num1 ) {
			n1=font[bcd_num1];
			n2=font[bcd_num2];
			}
			else
			{
			if ( bcd_num2 ){ 
			n2=font[bcd_num2]; 
			if ( znak ) n1=font[f_seg_g];
			}
			else
			if ( znak ) n2=font[f_seg_g];
			}
		}
		
		lcd_buffer[mesto]=n1;
		lcd_buffer[mesto+1]=n2;
		lcd_buffer[mesto+2]=font[bcd_num3];
		lcd_buffer[mesto+3]=font[bcd_num4];
		
		if (point) lcd_buffer[mesto+2]^=tochka;
			else if (bcd_num4>5) lcd_buffer[mesto+2]^=tochka;
		}
}


//**************************************
void tempir__clock_in_lcd(void){
	lcd_buffer[3]=font[f_gr];
	clock_in_lcd_gl(4);
}
void tempir_1_clock_in_lcd(void){
	tempir_in_bcd(ds0,0, pwire0, false );
	tempir__clock_in_lcd();
}
void tempir_2_clock_in_lcd(void){
	tempir_in_bcd(ds1,0,pwire1, false);
	tempir__clock_in_lcd();
}
//**************************************/
void tempir_2_in_lcd(unsigned char point){
	tempir_in_bcd(ds0,0,pwire0, point);
	tempir_in_bcd(ds1,5,pwire1, point);
}
//**************************************/
void tempir_2o_in_lcd(void){//temp o temp
	tempir_2_in_lcd(true);
	lcd_buffer[4]=font[f_gr];
}

void tempir_2oo_in_lcd(void){//temp o temp
	tempir_2_in_lcd(false);
	lcd_buffer[3]=font[f_gr];
	lcd_buffer[8]=font[f_gr];
}
//**************************************/
void grad_celsia(void){
	lcd_buffer[7]=font[f_gr];
	lcd_buffer[8]=font[f_C];
}
//**************************************/
void one_tempir_0_in_lsd(void){
	tempir_in_bcd(ds0,2,pwire0,true);//012345678 //inl
	grad_celsia();
	lcd_buffer[0]=font[f_d]^tochka;
}
//**************************************/
void one_tempir_1_in_lsd(void){
	tempir_in_bcd(ds1,2,pwire1,true);//0-00.0 *c //inl
	grad_celsia();
	lcd_buffer[0]=font[f_y]^tochka;
}
//**************************************/
void clock_in_lcd1(void)
{
	num2_bcd_in_lcd(1,hour[h_hour]);
	blank_nul(1);
	lcd_buffer[3]=font[f_seg_g];
	lcd_hh_mm(&hour[h_min]);
}
//**************************************
void timer_in_lcd(void)
{
    if (timer[3]&_BV(fl_timer_chet)) lcd_buffer[0]=font[f_t];
		else lcd_buffer[0]=font[f_seg_d];
	num2_bcd_in_lcd(1, timer[h_hour]);
	lcd_buffer[3]=font[f_seg_g];
	lcd_hh_mm(&timer[h_min]);
}

void num_month_year_constructor(uint8_t znmesto, uint8_t zn_year){
	
	lcd_buffer[zn_year]=font[2];
	lcd_buffer[zn_year+1]=font[0];
	num2_bcd_in_lcd(zn_year+2,hour[h_year]);
	
	num2_bcd_in_lcd(znmesto,hour[h_num]+1);
	lcd_buffer[znmesto+1]^=tochka;
	num2_bcd_in_lcd(znmesto+2,hour[h_month]+1);
	lcd_buffer[znmesto+3]^=tochka;
}

void num_month_year(void){
	num_month_year_constructor(1,5);
}

void num_month_year_day(void){
	num_month_year_constructor(0,2);
	day_str();
}

void num_month_year_daynum(void){
	lcd_buffer[0]=font[hour[h_day]+1];
	num_month_year_constructor(2,4);
	lcd_buffer[8]=font[f_r]^tochka;
}

void num_month_year_g(void){
	num_month_year_constructor(1,3);
	lcd_buffer[7]=font[f_r]^tochka;
}

//**************************************
void on__(unsigned char zn, unsigned char tr_fl){
unsigned char a,b;
	if (  tr_fl )
		{
		a=font[f_o];		
		b=font[f_n]^tochka;
		}
		else
		{
		a=font[f_seg_d];
		b=font[f_seg_d];
		}
	lcd_buffer[zn]=a;
	lcd_buffer[zn+1]=b;
}



//*************************************
void power_in_lcd(unsigned char pin_wire, unsigned char mesto){
unsigned char a,b;
	if ( !(pin_wire & out_1wire) ){
		a=font[f_seg_g];
		b=font[f_seg_g];
		}
		else
		if (power_suplly_1w & pin_wire )
		{
		a=font[f_P];
		b=font[f_A];	
		}
		else{
		a=font[f_o];
		b=font[f_n];
		}
	lcd_buffer[mesto]=a;
	lcd_buffer[mesto+1]=b;
}


/**************************************
void view_in_indikator(unsigned char view){
	if 			(view==0)	clock_in_lcd0();//num,day, hour-min
	else 	if 	(view==1)	clock_in_lcd1();//hour-min-sek
	else 	if	(view==2)	clock_in_lcd_gl(2);//clock_in_lcd2();//hour-min
	else 	if	(view==3)	clock_day_str();//hour-min day
	else 	if	(view==4)	num_month_day();//num_month day
	else	if	(view==5)	num_month_year();//31.12.2008
	else	if	(view==6)	num_month_year_day();//31.12.08 CP
	else 	if	(view==7)	tempir_2oo_in_lcd();
	else 	if	(view==8)	one_tempir_0_in_lsd();// _ -000 *C 1
	else	if	(view==9)	one_tempir_1_in_lsd();// _ -000 *C 2
	else	if	(view==10)	tempir_1_clock_in_lcd();// tempir0 hour-min
	else	if	(view==11)	tempir_2_clock_in_lcd();// tempir1 hour-min
	else 	if	(view==12)	tempir_2o_in_lcd();// 00.0 o 00.0
	else	if	(view==13)	tempir_2_in_lcd(true);// -00 -00//	
	else	if  (view==14) num_month_year_daynum();
	else num_month_year_g();
}*/

void view_in_indikator(unsigned char view){
  switch (view)
  {
    case (0): clock_in_lcd0(); 		break;//num,day, hour-min
    case (1): clock_in_lcd1();			break;//hour-min-sek
	case (2): clock_in_lcd_gl(2);		break;//hour-min
	case (3): clock_day_str();			break;//hour-min day
	case (4): num_month_day();			break;//num_month day
	case (5): num_month_year();		break;//31.12.2008
	case (6): num_month_year_day();	break;//31.12.08 CP
	case (7): tempir_2oo_in_lcd();		break;//00*  00*
	case (8): one_tempir_0_in_lsd();	break;// _ -000 *C 1
	case (9): one_tempir_1_in_lsd();	break;// _ -000 *C 2
	case (10): tempir_1_clock_in_lcd();break;// tempir0 hour-min
	case (11): tempir_2_clock_in_lcd();break;// tempir1 hour-min
	case (12): tempir_2o_in_lcd();		break;// 00.0 o 00.0
	case (13): tempir_2_in_lcd(true);	break;// -00 -00//
	case (14): num_month_year_daynum();break;//5 19.12.08.
    default: num_month_year_g();      	break;//19.12.08.
  }
}

//--------------------------------------
void indikator_manager(void){
unsigned char i, a;

	a=i=current_state_view.regim;	//  
	if ( ++i>=Count_regim ) i=0; //     ,  .
	
	while ( i!=a )
		{
		if (current_state_view.regim==a)
			{
			if  (reg_state_time.time[i] > 0)
				{
				if (current_state_view.skip[i]) //   , 
					current_state_view.skip[i]--;//   	 
					else 
					{
					current_state_view.regim=i;
					break;
					}
				}
			}
		if ( ++i>=Count_regim ) i=0;
		}
	
	i=current_state_view.regim;
	//if (i==a) 
	//i=0;//    ,    = 0
	current_state_view.time=		reg_state_time.time[i];
	current_state_view.skip[i]=		reg_state_time.skip[i];
	current_state_view.viewstate=	reg_state_time.regim[i];
}

//**************************************/
void data_lcd(void)
{
static uint8_t state_view_init=0;
 	cls_lcd_buffer();
	
	if (regim==0){
		if ( state_view_init ){
			state_view_init=0;
			current_state_view.viewstate= 0;
			current_state_view.time = 2;
			for(uint8_t i=0; i<Count_regim; i++)
					current_state_view.skip[i]=0;
			}
		view_in_indikator(current_state_view.viewstate);
		if (time_flag & _BV(fl_sig_otsr))
			if (!(time_flag&_BV(fl_sek_1_switch))) 
				lcd_buffer[8]^=tochka;
		return;
		}
		else{
		state_view_init=1;
		}
	
	if (regim==100){//       
		clock_in_lcd0();//    
		if (time_flag & _BV(fl_sig_otsr))	
			lcd_buffer[3]=font[f_o];//if (time_flag & _BV(fl_sig_otsr)) 
		return;
		}
	
	if  (regim==3) {timer_in_lcd(); return;}
	
	if (regim==7){//0, 0, f_C, f_A, f_L, f_L, f_S, 0, 0, //2,5
		load_str_in_lcdbuffer(&str_calls[0]);//load_str_in_lcdbuffer(&str_[0]);
		return;
	    }
	if  (regim==9){//0, 0, S, E, t, U, P, 0, 0 //2,5
		load_str_in_lcdbuffer(&str_setup[0]);
		return;
		}//*/
	if  (regim==8){//0, t, i, m1, m2, E, R, 0, 0 // 1,6
		load_str_in_lcdbuffer(&str_timmer[0]);
		return;
		}
	if  (regim==215){//0, 0, L, I, G, H, t, 0, 0 //2,5
		load_str_in_lcdbuffer(&str_light[0]);
		return;
		}
	//light	
	if  (regim==11){
		lcd_buffer[0]=font[f_L];
	    for(uint8_t i=0; i<lights[day_light]; i++)
			lcd_buffer[i+1]=font[f_o];
		lcd_light=lights[day_light];
		return;
		}
	if  (regim==14){//H, O, 4, b, 0, L., -, 0, 0 //0,6 
		load_str_in_lcdbuffer(&str_light_noch[0]);
		lcd_buffer[7]=font[lights[night_light]];
		lcd_light=lights[night_light];
		return;
		}// end light
	if  ( (regim>14)&&(regim<17) ){//H, O, 4, b, 0, L., -, 0, 0 //0,6 
		lcd_buffer[1]=font[f_c];
		num2_bcd_in_lcd(2,lights[tim_c_light]);
		lcd_buffer[5]=font[f_d];
		lcd_buffer[6]=font[f_o];
		num2_bcd_in_lcd(7,lights[tim_do_light]);
		return;
		}// end light
	
	
	//----------------------------
	if (regim==211){//0, 0, 4, A, C, b, I, 0, 0// 2,5
		load_str_in_lcdbuffer(&str_clock[0]);
		return;
	    }
	if ( (regim>=r_clock)&&(regim<=r_clock+2) ){
	   	clock_in_lcd1();//hour-min-sek   clock_in_lcd0();
		return;
	    }
	if ( ( regim>=r_clock+3 )&&( regim<=r_clock+6 ) ){//01.08.08
		num_month_year_day();
		return;
	   	}

	if ((regim>=r_clock+7)&&(regim<=r_clock+8)){//C, o, r, r., //0x39, 0x9C, 0x14, 0x54,
		load_str_in_lcdbuffer(&str_corr[0]);
		if ( corr_flag&_BV(fl_corr_znak_pl) ) lcd_buffer[4]=font[f_seg_d]; 
	   	  else 							   	 lcd_buffer[4]=font[f_seg_g];   
		lcd_buffer[5]=font[n0]^tochka; 
		result_in_bcd( pgm_read_word_near(&corr_in_lcd[correction]) );
		lcd_buffer[6]	=font[bcd_num2];
		lcd_buffer[7]	=font[bcd_num3];
		lcd_buffer[8]	=font[bcd_num4];
		return;
		}	

	if ((regim>30)&&(regim<35)){
	   	lcd_buffer[0]=font[budilnik_nomer];
		lcd_hh_mm(&calls[ budilnik_nomer ] [c_hour]);
		on__(1, ((calls[ budilnik_nomer ] [2]) & (_BV(7))) );
		return;
		}	
	if ((regim>44)&&(regim<47)){
		lcd_buffer[0]=font[f_H];
		lcd_buffer[1]=font[f_A];
		lcd_hh_mm(&calls_pin[budilnik_nomer-10][c_hour]);
		return;
		}	
	if ((regim>34)&&(regim<42)){
	    lcd_buffer[0]=font[f_d]^tochka;
		for (uint8_t i=0; i<7; i++){
			if ((calls[ budilnik_nomer ] [2])&_BV(i))
			lcd_buffer[i+2]=font[i+1]; else lcd_buffer[i+2]=font[f_seg_d];
			}
		return;
		}
	//--SIGNAL--
	if (regim==216){//0, S, I, G, H, A, L, 0, 0 //1,6
		load_str_in_lcdbuffer(&str_signal[0]);
		return;
	    }
	if (regim==52){//0, b, u, d, I, I., 0, 0, S //1,8 
		if (ocr1[4]==0)	load_str_in_lcdbuffer(&str_budil[0]); 
		else				load_str_in_lcdbuffer(&str_button[0]);	
		lcd_buffer[8]=font[f_S];
		return;
		}
	if ((regim>=53)&&(regim<=54)){
		if (ocr1[4]==0){
			signal=10;
			time_signal=10;
			time_flag|= _BV(fl_signal_out_enable);
			}
		lcd_buffer[0]=font[f_H];
		result_in_bcd(ocr1[ocr1[4]*2]);
		num3_th_in_lcd_buffer(1);
		lcd_buffer[5]=font[f_L];
		result_in_bcd(ocr1[ocr1[4]*2+1]);
		num3_th_in_lcd_buffer(6);
		return;
		}
	//--END--SIGNAL--

	   
	if (regim==218){//d, E, F, A, U, L, t, 0, S, //0,9
		load_str_in_lcdbuffer(&str_default[0]);
		return;
	    }
	if (regim==212){//0, 0, P, o, r, t, 0, 0, 0, //2,4
		load_str_in_lcdbuffer(&str_port[0]);
		return;
	    }
	if ( regim==71 ){//_pin-0_ _c	//0, P, i, n, -, 0000 1,4
		load_str_in_lcdbuffer(&str_pin_c[0]);
		if ( PINC & PIN_calls1 ) lcd_buffer[5]=font[n1];
		   						   else lcd_buffer[5]=font[n0]; 
		lcd_buffer[8]=font[f_C]^tochka;
		return;
	   	}
	//===============================
	if ( regim==214 ){//  _yct_bud_ //0, y, C, t, 0, 6, u, d., 0 //1,7 
		load_str_in_lcdbuffer(&str_yst_bud[0]);
		return;
	    }
	if (regim==75){
		load_str_in_lcdbuffer(&str_cal[0]);
		if (signal_bud==0){
		   load_str_in_lcdbuffer(str_bip);
			}
			else
			if (signal_bud==1){
			load_str_in_lcdbuffer(&str_pin[0]);
			}
			else{
			load_str_in_lcdbuffer(&str_oba[0]);
			}
		return;
	    }
	if (regim==76){//O, t, S, R, O, 4., 0, 0, 0 //0,6
		load_str_in_lcdbuffer(&str_otsro4[0]);
		num2_bcd_in_lcd(7,otsroshka_num);
		return;
		}
		
	if 	((regim>79)&&(regim<84)) {timer_in_lcd(); return;}
	
	if (regim==213){//t see	//{}//0, Y, C, t, 0, S, E, E, 0 //1,7 
	    load_str_in_lcdbuffer(&str_yst_see[0]);
		return;
	    }
	if ((regim>90)&&(regim<95)) {
		lcd_buffer[0]=font[current_state_view.regim+1];
		lcd_buffer[1]=font[f_r];
		lcd_buffer[2]=font[reg_state_time.regim[current_state_view.regim] ];
		
		lcd_buffer[4]=font[f_c];
		num2_bcd_in_lcd(5,reg_state_time.time[current_state_view.regim]);
		lcd_buffer[7]=font[f_n]^tochka;
		lcd_buffer[8]=font[reg_state_time.skip[current_state_view.regim] ];
		return;
		}
	
	if (regim==217){//d, S, 1, 8, b, 2, 0, 0, F // 0,9
		load_str_in_lcdbuffer(&str_ds18b20[0]);
		return;
		}
	if (regim==111){
		if (vid_t==0) 
			load_str_in_lcdbuffer(&str_vid1_t[0]);
			else
			load_str_in_lcdbuffer(&str_vid2_t[0]);
			
		return;
		}
	if (regim==112){
		load_str_in_lcdbuffer(&str_pit[0]);
		power_in_lcd(pwire0, 4);
		power_in_lcd(pwire1, 7);
		return;
		}
	
	if (regim==150){// 
		if (time[beg_str]<=0){
			time[beg_str]=45;
			simvol++;
			if (simvol==str_length+9) simvol=0;
			}
		for (uint8_t a=0, i=simvol; a<9 ; i++, a++){
				if ( (i>8)&&(i<str_length+9) )
					lcd_buffer[a]=*(ukaz_na_str+i-9);//str[i-9];
			}
		}
}
//**************************************
void str_init(void){
unsigned char h;
	//0-5; 6-11; 12-17; 18-23;
	
	h=hour[h_hour];
	if (h<6)	ukaz_na_str=&str_noch[0];	else
	if (h<12)	ukaz_na_str=&str_utro[0];	else
	if (h<18)	ukaz_na_str=&str_day[0];	else
				ukaz_na_str=&str_vecher[0];

	*(ukaz_na_str+5)=font[budilnik_nomer];
	result_in_bcd(hour[h_hour]);
	*(ukaz_na_str+7)=font[bcd_num3];
	*(ukaz_na_str+8)=font[bcd_num4];
	result_in_bcd(hour[h_min]);
	*(ukaz_na_str+10)=font[bcd_num3];
	*(ukaz_na_str+11)=font[bcd_num4];
}

//**************************************
void init_signal(void){
	str_init();
	simvol = count_note = 0;
	time[note]=3;
	signal=1;
	time_in_regim = time_signal = 59;
	time_flag &=~  _BV(fl_signal_cls); //   
	time_flag |=   _BV(fl_signal_out_enable);//   
}

void shim(void){
unsigned char tmp;
	if (time[note]<=0)
		{
		tmp=uprav_TCCR1B[count_note];
		if (tmp&0x01)	timer1_init_in_pwm();
			else		timer1_init();
		time[note]=length_note[count_note];
		TCCR1B=tmp;
		if ( ++count_note == 4 ) count_note=0;
		}
}

void budilnik_out(void){
if (!signal_bud){
	shim();
	}
	else 
	if (signal_bud==1){
		PORT_OUT|=PIN_calls_osn;	
		}
	else{
	shim();
	PORT_OUT|=PIN_calls_osn;
	}
}

void signal_off(void)
{
//   ---------------------------
	if ( time_signal==0 )
	{	
		if (signal==0) //   
		{
		if ( time_flag & _BV(fl_sig_otsr) ) //   
			{
			if ( budilnik_play_num++==otsroshka_num ) {//  .  X , //
				time_flag &= ~_BV(fl_sig_otsr);
				}
				else{//   ,   ,   
				init_signal();
				regim=150;
				signal=1;//sig_on_otsr;
				return;//   
				}
			}
		}
		else
		time_flag |= _BV(fl_signal_cls);//    
	}
//  
	if ( !( time_flag & _BV(fl_sig_butt) ) )
	if ( time_flag & _BV(fl_signal_cls) )//  
		{
		time_flag &=~  (_BV(fl_signal_cls)|_BV(fl_signal_out_enable));
			
		PORT_OUT &=~  PIN_calls_osn;
		PORT_OUT &=~  PIN_timer;
		timer1_init();
		
		time_signal=0xFF;	
	
		signal=0;
		}
}
//*************************************/

//**************************************
void calls_verify(void)
{
unsigned char i;
	for(i=0;i<12;i++)
	if ( _BV(7) & calls[i][c_day] )				//  
	 if ( _BV(hour[h_day]) & calls[i][c_day] )	// 
	  if (calls[i][c_hour]==hour[h_hour])			//
	   if (calls[i][c_min]==hour[h_min])			//
		{
		if (i<10){
			budilnik_nomer=i;
			budilnik_play_num=0;//           
			if ( otsroshka_num ) time_flag |= _BV(fl_sig_otsr);
			init_signal();
			regim=150;
			} 
			else{
			calls_pin_chet[c_hour]=calls_pin[i-10][c_hour];
			calls_pin_chet[c_min]=calls_pin[i-10][c_min];
			timer[3]|=_BV(fl_calls_pin_A_on);
			PORT_OUT|= PIN_calls1 ;
			}
		}
}
//**************************************
void calls_pin_verify(void){

	if (timer[3]&_BV(fl_calls_pin_A_on))
	{
	if	(!calls_pin_chet[c_hour])
	 if (!calls_pin_chet[c_min])
		{
		timer[3]&=~_BV(fl_calls_pin_A_on);
		PORT_OUT&=~ PIN_calls1 ;	
		return;
		}
	
	if ( --calls_pin_chet[c_min]<0 ){
	  	calls_pin_chet[c_min]=59;
		calls_pin_chet[c_hour]--;
		}
	}
	
}

//**************************************
void timer_verify(void){
	if (timer[3]&_BV(fl_timer_chet))
	{
	if		(!timer[h_hour])
	 if 	(!timer[h_min])
	  if	(!timer[h_sek])	
		{
		//signal=2;
		regim=80;
		timer[3]&=~_BV(fl_timer_chet);
		init_signal();	
		return;
		}
	if ( --timer[h_sek]<0 ){
	  	timer[h_sek]=59;
		timer[h_min]--;
		if ( timer[h_min]<0 ){
		 	timer[h_min]=59;
			timer[h_hour]--;
			}
		}
	}
}
//**************************************

void clock(void){

  if ( isr_1sek_ )// 
	{
	correct=0;
	if (++hour[h_sek]>=60)
		{
		hour[h_sek] =0;
		if (++hour[h_min]>=60)
			{
			if ( corr_flag & _BV(fl_corr_znak_pl) )// 
				correct=correction;// 
				else
				correct= 0x00-correction;
			
			hour[h_min] =0;
			hour[h_hour]++;
	
			if (hour[h_hour]>=24)
				{
				hour[h_hour]=0;
				if (++hour[h_day]>7-1)	hour[h_day]=0;
				if (++hour[h_num]>num_in_month[ hour[h_month] ] )
					{
					hour[h_num]=0;
					hour[h_month]++;
					if (hour[h_month]>12-1) {hour[h_month]=0; hour[h_year]++;}
					}
				}
			
			if ( hour[h_hour] == lights[tim_c_light])	lcd_light=lights[night_light];
			if ( hour[h_hour] == lights[tim_do_light])	lcd_light=lights[day_light];
			if (!pin_power_)
				if (lcd_light==lights[day_light])
					PORT_sig_min|=sig_min_00;
			}
		calls_verify();//    
		calls_pin_verify();//    calls_verify
		}
	isr_1sek_=0;
	}
}

//****************************************
void time_count(void){
static unsigned char t, sek;
	if ( t != clock_ )
		{//  0,0078125 .
		t=clock_;
		if (t>=64) time_flag|=_BV(fl_sek_1_switch); else time_flag&=~_BV(fl_sek_1_switch);
		for (uint8_t i=0; i<4; i++) time[i]--;
		
		if ( time_flag & _BV(fl_sig_butt) )//    
			if (time[note_but]<0)
			{
			time_flag&= ~ _BV(fl_sig_butt);
			timer1_init();
			}
		
		if (sek!=hour[h_sek]){// 
			sek=hour[h_sek];
			
			if (regim==0)
				if (--current_state_view.time == 0 ) indikator_manager();
			if (--time_in_regim == 0 )
						if (regim>=4) regim=0;
			time_signal--;
			timer_verify();
			if ( PORT_sig_min & sig_min_00 ) if (sek>0) //if (lcd_light==lights[day_light])
			PORT_sig_min&=~sig_min_00;
			}
		//  
		signal_off();
		if ( time_flag & _BV(fl_signal_out_enable) ) budilnik_out();//       
		if ( time_flag & _BV(fl_power_init_device) )//   
			skankey();
			
		
		if (regim>=4)//if (mask)
			{
			static uint8_t time_mig=0;
			if (++time_mig>=light_time_mig[lcd_light])//(10-lcd_light)
				{
				time_mig=0;
				change_light_var();
				}
			}
		}
}//*/
//*/**************************************
void init_devices_save_mode(void)
{
	TIMSK = _BV(TOIE2);//|(1<<OCIE1A)
	
	PORTSERIAL|=_BV(STORAGE);//  
	#ifdef katod
	PORTLCD=0;
	data_shift(0xFF);
	#else
	PORTLCD=0xFF;
	data_shift(0);
	#endif
}//*/
//**************************************
int main(void)
{
	
	cli();
	read_data_EEPROM();
	timer2_init();
	init_devices();


while(1)
 {//while
 clock();
   if (!pin_power_)
	{//begin power on
	 	if (time_flag&_BV(fl_power_init_device))
			{
			time_flag &= ~( _BV(fl_power_init_device) | _BV(fl_sig_otsr) );
			//time_flag &= ~_BV(fl_sig_otsr);//     .    
			init_devices();
			current_state_view.time=2;
			time_in_regim=2;
			}
		/* */   
		if (lcd_time_switch>=30)/* 2msek*/ 
	  	   	{
			PORTSERIAL|=_BV(STORAGE);
			lcd_time_switch=0x00;
  	   		if  (++znakomesto<9) {
				light=light_swith[opred_light_current_num()];//   
				skankey(); //    :)
				display();//  
				key_action();//   
				}
				else	
				{
				//PORTSERIAL|=_BV(STORAGE);//  
				#ifdef katod
				PORTLCD=0x00;
				data_shift(0xFF);
				#else
				PORTLCD=0xFF;
				data_shift(0);
				#endif
				
				
				if (regim){
					uint8_t l=lights[day_light];
					if ( lights[tim_do_light]>lights[tim_c_light] )
						{
						if ( (hour[h_hour] < lights[tim_do_light] )&&( hour[h_hour] >= lights[tim_c_light] ) ) 
							l=lights[night_light]; else l=lights[day_light];
						}
						else
						{
						if ( (hour[h_hour] >= lights[tim_do_light] )&&( hour[h_hour] < lights[tim_c_light] ) ) 
							l=lights[day_light]; else l=lights[night_light];
						}
					lcd_light=l;
					}
					
				data_lcd();
				znakomesto=0xFF;
				lcd_time_switch=27;
				}
	  		}

		time_count();
		if (lcd_time_switch<5) izmerenie_t();	/* */

	}//end power on
	 else
	{
	if (!(time_flag&_BV(fl_power_init_device)))
		{
		time_flag|=_BV(fl_power_init_device);
		init_devices_save_mode();
		}
	
	//clock();
	if ( signal || ( time_flag & _BV(fl_sig_butt) ) )//          
		{
		time_count();
		if (key!=17){
			time_flag |=  _BV(fl_signal_cls);
			time_flag &= ~_BV(fl_signal_out_enable);
			}
		}
		else
		{//        
		MCUCR = BIT(SM1)|BIT(SM0)|BIT(SE);
		asm("sleep");
		MCUCR=0;
		}

	}
 }//while

}

//**************************************
ISR(SIG_OVERFLOW0){//0,000064
 	lcd_time_switch++;
	if (lcd_time_switch==light)
		#ifdef katod 
		PORTLCD=lcd_buffer[znakomesto];
		#else
		PORTLCD=~lcd_buffer[znakomesto];
		#endif
}
//**************************************
ISR(SIG_OVERFLOW2)
{
 clock_++;
 if (clock_==128)
	{	   	 		  	   	  				   	
	clock_=correct;
	isr_1sek_=1;
  	}
}
